import {Step} from "./pagenote-step";

declare enum BAR_STATUS{
    fold,
    expand,
}

export class OptionsProps{
    initType?: string;
    dura?: number;
    saveInURL?: boolean;
    saveInLocal?: boolean;
    maxMarkNumber?: number;
    enableMarkImg?: boolean;
    blacklist: string[];
    autoLight?: boolean;
    barInfo?: {right:number,top:number,status:BAR_STATUS};
    actionBarOffset?: {offsetX:number,offsetY:number};
    showIconAnimation?: boolean;
    onShare?: object;
    functionColors: string[];
    sideBarActions: string[];
    categories: string[];
    showBarTimeout?: number;
    keyupTimeout?: number;
}

export interface Pagenote {
    options: OptionsProps;

    record(info:object): Step;
    remove(index:number): boolean;
    replay(index:number,goto:boolean,autoNext:boolean,isActive:boolean): void;
    makelink(fun: any): void;
    openModal(): void;
    _syncModal(): void;
    generateMD(): void;
    notification(message: string,type: string,duration:number,position:{x:string,y:string}): void;
    capture(target: HTMLElement): void;
    triggerListener(): void;

    decodeData(): string;
    encryptData(): string;

    // 导出数据为其他格式
    exportData(template: string, data: any): string;
}
